> For the complete documentation index, see [llms.txt](https://docs.appstrategy.com/apprules-r-documentation/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.appstrategy.com/apprules-r-documentation/appendix/miscellaneous/picklists.md).

# PickLists

## Using PickLists

appRules includes activities for managing data source picklists (option sets).

The activities are in the appConnector.List module (see [Base Activities](/apprules-r-documentation/platform/platform-features/base-activities/base-activities-1.md) User Guide):

\- LookupPickListRecord

\- IsPickListValueValid

PickLists can be entered manually or generated automatically when data source metadata is created.  For example, when a Microsoft Dynamics CRM or Salesforce data sources are created, the system automatically creates the picklists for all entities.

![](https://1923141441-files.gitbook.io/~/files/v0/b/gitbook-legacy-files/o/assets%2Fdocumentation%2F-MFzEIWJn01EnW45Va1R%2F-MFzEUlbri-x1fH_ntHL%2F0.jpeg?generation=1598788861568417\&alt=media)

When a picklist entry is defined, you can also enter alternate values associated with the entry.  This feature can be used for looking up values for picklist entries.  In the example below, when the Account.customertypecode entry is loaded, the three alternate values associated with it are also loaded and can be used any where in your project.

![](https://1923141441-files.gitbook.io/~/files/v0/b/gitbook-legacy-files/o/assets%2Fdocumentation%2F-MFzEIWJn01EnW45Va1R%2F-MFzEUlcQc3Jh6xLD2UU%2F1.jpeg?generation=1598788861581888\&alt=media)

## LookupPickListRecord Activity

The LookupPickListRecord activity which is part of the module, allows you to load the values of a picklist into a record.  The record values (key/description) can then be used in the running project just like other values (using “DataFieldValue” source value).

## IsPickListValid Activity

The IsPickListValid activity which is part of the appConnector.List module, checks whether a value belongs to a picklist.   The value can be the key or description of the picklist.   The activity returns True or False and can be directly tested using the ActivityResult condition type.


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.appstrategy.com/apprules-r-documentation/appendix/miscellaneous/picklists.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
